commit 08fb2ae2ee946bda917d53b8c5873efd0dfc4ff5
Author: freddy77 <freddy77>
Date:   Wed Sep 30 11:52:05 2009 +0000

    Avoid memory problems logging data

diff --git a/ChangeLog b/ChangeLog
index 1a8461d..5965746 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Wed Sep 30 13:51:16 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/log.c: Avoid memory problems logging data
+
 Tue Sep 29 11:15:56 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/convert.c: fix float to money precision during conversion
 
@@ -1853,4 +1856,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2873 2009/09/29 09:16:10 freddy77 Exp $
+$Id: ChangeLog,v 1.2874 2009/09/30 11:52:05 freddy77 Exp $
diff --git a/src/tds/log.c b/src/tds/log.c
index e7401b7..6f02624 100644
--- a/src/tds/log.c
+++ b/src/tds/log.c
@@ -66,7 +66,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: log.c,v 1.12 2009/02/27 10:07:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: log.c,v 1.13 2009/09/30 11:52:06 freddy77 Exp $");
 
 /* for now all messages go to the log */
 int tds_debug_flags = TDS_DBGFLAG_ALL | TDS_DBGFLAG_SOURCE;
@@ -466,15 +466,19 @@ tdsdump_col(const TDSCOLUMN *col)
 	
 	switch(type) {
 	case SYBCHAR: 
-	case SYBVARCHAR: 
-		data = calloc(1, 1 + col->column_cur_size);
-		if( !data ) {
-			tdsdump_log(TDS_DBG_FUNC, "no memory to log data for type %s\n", typename);
-			return;
+	case SYBVARCHAR:
+		if (col->column_cur_size >= 0) {
+			data = calloc(1, 1 + col->column_cur_size);
+			if (!data) {
+				tdsdump_log(TDS_DBG_FUNC, "no memory to log data for type %s\n", typename);
+				return;
+			}
+			memcpy(data, col->column_data, col->column_cur_size);
+			tdsdump_log(TDS_DBG_FUNC, "type %s has value \"%s\"\n", typename, data);
+			free(data);
+		} else {
+			tdsdump_log(TDS_DBG_FUNC, "type %s has value NULL\n", typename);
 		}
-		memcpy(data, col->column_data, col->column_cur_size);
-		tdsdump_log(TDS_DBG_FUNC, "type %s has value \"%s\"\n", typename, data); 
-		free(data);
 		break;
 	case SYBINT1: 
 		tdsdump_log(TDS_DBG_FUNC, "type %s has value %d\n", typename, (int)*(TDS_TINYINT*)col->column_data); 

